package visitor;

import syntaxtree.*;

public interface GenVisitor<A,R> {
  public R visit(Program n, A a);
  public R visit(MainClass n, A a);
  public R visit(ClassDeclSimple n, A a);
  public R visit(ClassDeclExtends n, A a);
  public R visit(VarDecl n, A a);
  public R visit(MethodDecl n, A a);
  public R visit(Formal n, A a);
  public R visit(IntArrayType n, A a);
  public R visit(BooleanType n, A a);
  public R visit(IntegerType n, A a);
  public R visit(IdentifierType n, A a);
  public R visit(Block n, A a);
  public R visit(If n, A a);
  public R visit(While n, A a);
  public R visit(Print n, A a);
  public R visit(Assign n, A a);
  public R visit(ArrayAssign n, A a);
  public R visit(And n, A a);
  public R visit(LessThan n, A a);
  public R visit(Plus n, A a);
  public R visit(Minus n, A a);
  public R visit(Times n, A a);
  public R visit(ArrayLookup n, A a);
  public R visit(ArrayLength n, A a);
  public R visit(Call n, A a);
  public R visit(IntegerLiteral n, A a);
  public R visit(True n, A a);
  public R visit(False n, A a);
  public R visit(IdentifierExp n, A a);
  public R visit(This n, A a);
  public R visit(NewArray n, A a);
  public R visit(NewObject n, A a);
  public R visit(Not n, A a);
  public R visit(Identifier n, A a);
}
